# -*- coding: utf-8 -*-

#######################################################################
# Copyright © 2007 Yuri Malheiros.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# the Free Software Foundation; version 2 only.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#######################################################################

"""
This module implements a class responsible for creating the TextFlow's status bar.
"""

import gtk
from TextFlow.core import constants

class StatusBar(gtk.HBox):
    def __init__(self):
        """
        Constructor.
        """
        super(StatusBar, self).__init__()
        
        self.statusbar_line = gtk.Statusbar()
        self.statusbar_line.set_has_resize_grip(False)
        self.statusbar_column = gtk.Statusbar()
        self.statusbar_column.set_has_resize_grip(False)
        self.statusbar_end = gtk.Statusbar()
        self.statusbar_end.set_size_request(15,0)
        
        
        button = gtk.Button("teste")
        
        # Close button style (little button)
        close_button_style = ''' 
            style 'close_button' {
                xthickness = 0
                ythickness = 5
            }
            widget '*.close_button' style 'close_button'
        '''
        gtk.rc_parse_string(close_button_style)
        
        button.set_name('sidepanel.close_button')
        button.set_relief(gtk.RELIEF_NONE)
        #button_hbox = gtk.VBox()
        #button_hbox.pack_start(button, False, False, 0)
        #button_hbox.set_child_packing(button, False, True, 0, gtk.PACK_END)
        
        
        #self.pack_start(self.statusbar_end, False, False)
        #self.pack_start(button_hbox, False, False)
        
        #self.pack_start(self.statusbar_line, True, True, 6)
        #self.pack_start(self.statusbar_column, False, True, 6)
        
        #self.set_child_packing(self.statusbar_line, False, True, 0, gtk.PACK_END)
        #self.set_child_packing(self.statusbar_column, False, True, 0, gtk.PACK_END)
        #self.set_child_packing(button_hbox, False, False, 0, gtk.PACK_END)
        #self.set_child_packing(self.statusbar_end, False, True, 0, gtk.PACK_END)
        #self.set_size_request(0, 25)
        
        #print self.statusbar_line.get_children()
        #print self.statusbar_line.get_children()[0].get_children()
        
        #self.statusbar_column.get_children()[0].remove(self.statusbar_column.get_children()[0].get_children()[0])
        #self.statusbar_column.get_children()[0].add(button)
        
        
        ########################################
        
        self.statusbar = gtk.Statusbar()
        status_hbox = gtk.HBox()
        status_hbox.set_spacing(12)
        self.line_label = gtk.Label("")
        self.col_label = gtk.Label("")
        
        self.statusbar.get_children()[0].remove(self.statusbar.get_children()[0].get_children()[0])
        self.statusbar.get_children()[0].add(status_hbox)
        self.pack_start(self.statusbar, True, True, 0)
        status_hbox.pack_start(self.line_label, False, False, 0)
        status_hbox.pack_start(self.col_label, False, False, 0)
        
    def set_line_column(self, line_num, col_num):
        self.line_label.set_text(constants.MESSAGE_0016 + str(line_num))
        self.col_label.set_text(constants.MESSAGE_0017 + str(col_num))
        
    def clear(self):
        self.line_label.set_text("")
        self.col_label.set_text("")
